setwd("~/Master2/Mmoire")
Datadeg <- read.csv("datadgats.csv", header = T, sep = ";", dec = ",")
Datadeg$Morphotype <- as.factor(Datadeg$Morphotype)
Datadeg_Damaged_only <- read.csv("datadgats_3.0.csv", header = T, sep = ";", dec = ",")
Datadeg_Damaged_only$Morphotype <- as.factor(Datadeg_Damaged_only$Morphotype)

length(which(Datadeg$Type.1 != "/"))
length(which(Datadeg[-which(Datadeg$Type.1 != "/"),]$Type != "/"))

#pourcentage de spcimens edommags dans la flore tudie
Datadegterr <- Datadeg[-which(Datadeg$Morphotype == ""),]
attach(Datadegterr)
length(which(Datadegterr$Type != "/"))/length(rownames(Datadegterr))*100
propdeg <- matrix(c(length(which(Datadegterr$Type == "/"))/length(rownames(Datadegterr))*100, length(which(Datadegterr$Type != "/"))/length(rownames(Datadegterr))*100, length(which(Datadeg[-which(Datadeg$Type.1 != "/"),]$Type != "/"))/length(rownames(Datadegterr))*100, length(which(Datadeg$Type.1 != "/"))/length(rownames(Datadegterr))*100))
rownames(propdeg) <- c("undamaged", "damaged", "1DT", "2DT")
par(cex = 0.9)
x <- barplot(propdeg, beside = T, col = c("chartreuse", "orchid4", "seagreen", "tomato"), names.arg = rownames(propdeg), space = 0.9, legend.text = T)
y <- round(propdeg[,1], digits = 2)
text(x,c(y[1:3]/2, y[4]+2),labels=as.character(round(y, digits = 2)))

#Pourcentage par morphotype
as.factor(levels(Morphotype))
Datadegterr
orderedmorphotypeterr <- c(levels(Morphotype)[2], levels(Morphotype)[13], levels(Morphotype)[24], levels(Morphotype)[27], levels(Morphotype)[28], levels(Morphotype)[29], levels(Morphotype)[30], levels(Morphotype)[31], levels(Morphotype)[32], levels(Morphotype)[3], levels(Morphotype)[4], levels(Morphotype)[5], levels(Morphotype)[6], levels(Morphotype)[7], levels(Morphotype)[8], levels(Morphotype)[9], levels(Morphotype)[10], levels(Morphotype)[11], levels(Morphotype)[12], levels(Morphotype)[14], levels(Morphotype)[15], levels(Morphotype)[16], levels(Morphotype)[17], levels(Morphotype)[18], levels(Morphotype)[19], levels(Morphotype)[20], levels(Morphotype)[21], levels(Morphotype)[22], levels(Morphotype)[23], levels(Morphotype)[25], levels(Morphotype)[26], levels(Morphotype)[33])
nspecimens <- c(1:32)
for (m in 1:32) {
  nspecimens[m] <- length(rownames(Datadegterr[Morphotype == as.character(orderedmorphotypeterr[m]),]))
  }

Datadegterr[Morphotype == "GL1",]
length(which(Datadegterr[Morphotype == "GL1","Type"] != "/"))/length(rownames(Datadegterr[Morphotype == "GL1",]))*100
propGL <- matrix(c(length(which(Datadegterr[Morphotype == "GL1","Type"] == "/"))/length(rownames(Datadegterr[Morphotype == "GL1",]))*100, length(which(Datadegterr[Morphotype == "GL1","Type"] != "/"))/length(rownames(Datadegterr[Morphotype == "GL1",]))*100), nrow = 2, ncol = 1)
rownames(propGL) <- c("undamaged", "damaged")

for (p in 2:32) {
  propGL <- cbind(propGL, c(length(which(Datadegterr[Morphotype == as.character(orderedmorphotypeterr[p]),"Type"] == "/"))/length(rownames(Datadegterr[Morphotype == as.character(orderedmorphotypeterr[p]),]))*100, length(which(Datadegterr[Morphotype == as.character(orderedmorphotypeterr[p]),"Type"] != "/"))/length(rownames(Datadegterr[Morphotype == as.character(orderedmorphotypeterr[p]),]))*100))
}

colnames(propGL) <- c("GL1", "GL2", "GL3", "GL4", "GL5", "GL6", "GL7", "GL8", "GL9", "GL10", "GL11", "GL12", "GL13", "GL14", "GL15", "GL16", "GL17", "GL18", "GL19", "GL20", "GL21", "GL22", "GL23", "GL24", "GL25", "GL26", "GL27", "GL28", "GL29", "GL30", "GL31", "GLU")
par(cex = 0.5)
x2 <- barplot(propGL, beside = T, col = c("chartreuse", "orchid4"), names.arg = colnames(propdeg), legend.text = T)
rbind(propGL, as.character(nspecimens))

#Ajust pour la quantit de spcimens par morphotypes
length(which(Datadegterr[Morphotype == "GL1","Type"] != "/"))/length(rownames(Datadegterr))*100
propGLtot <- matrix(c(length(which(Datadegterr[Morphotype == "GL1","Type"] == "/"))/length(rownames(Datadegterr))*100, length(which(Datadegterr[Morphotype == "GL1","Type"] != "/"))/length(rownames(Datadegterr))*100), nrow = 2, ncol = 1)
rownames(propGLtot) <- c("undamaged", "damaged")

for (p in 2:32) {
  propGLtot <- cbind(propGLtot, c(length(which(Datadegterr[Morphotype == as.character(orderedmorphotypeterr[p]),"Type"] == "/"))/length(rownames(Datadegterr))*100, length(which(Datadegterr[Morphotype == as.character(orderedmorphotypeterr[p]),"Type"] != "/"))/length(rownames(Datadegterr))*100))
}

colnames(propGLtot) <- c("GL1", "GL2", "GL3", "GL4", "GL5", "GL6", "GL7", "GL8", "GL9", "GL10", "GL11", "GL12", "GL13", "GL14", "GL15", "GL16", "GL17", "GL18", "GL19", "GL20", "GL21", "GL22", "GL23", "GL24", "GL25", "GL26", "GL27", "GL28", "GL29", "GL30", "GL31", "GLU")
par(cex = 0.5)
barplot(propGLtot, beside = T, col = c("chartreuse", "orchid4"), names.arg = colnames(propdeg), legend.text = T)
detach(Datadegterr)

#type de dgts par morphotype
Datadeg_Damaged_only <- Datadeg_Damaged_only[, -c(7,8)]
attach(Datadeg_Damaged_only)
Type <- as.factor(Type)
orderedmorphotype <- c(levels(Morphotype)[1], levels(Morphotype)[7], levels(Morphotype)[13], levels(Morphotype)[15], levels(Morphotype)[16], levels(Morphotype)[17], levels(Morphotype)[18], levels(Morphotype)[2], levels(Morphotype)[3], levels(Morphotype)[4], levels(Morphotype)[5], levels(Morphotype)[6], levels(Morphotype)[8], levels(Morphotype)[9], levels(Morphotype)[10], levels(Morphotype)[11], levels(Morphotype)[12], levels(Morphotype)[14], levels(Morphotype)[19])
DTclass  <- matrix(c(1, 9, 13, 17:20, 22, 24, 26, 27, 29, 31, 32, 34, 37, 40, 7, 8, 21, 38, 41, 5, 6, 12, 14, 15, 10, 23, 33, 36, 39, 2, 28, 3, 11, 16, 35, 25, 30, 4), ncol = 41)
colnames(DTclass) <- c("galles (DTNA)", "galles (DT189)", "galles (DT145)", "galles (DT125)", "galles (DT80)", "galles (DT354)", "galles (DTNA/382?)", "galles (DT279)", "galles (DT87)", "galles (DT335)", "galles (DT241)", "galles (DT254)", "galles (DT188)", "galles (DT110)", "galles (DT303)", "galles (DT32)", "galles (DT289)", "pathogne (DT263)", "pathogne (DT388)", "pathogne (DTNA/334)", "pathogne (DT334)", "pathogne (DTNA/375)", "broutage des marges (DT15)", "broutage des marges (DT340)", "broutage des marges (DT395)", "broutage des marges (DT12)", "broutage des marges (DT200)", "broutage par perforation (DT64)", "broutage par perforation (DT02)", "broutage par perforation (DT78)", "broutage par perforation (DTNA/04)", "broutage par perforation (DT06)", "mines (DT65)", "mines (DT41)", "perforation et succion (DT290)", "perforation et succion (DT138)", "perforation et succion (DT165)", "perforation et succion (DT281)", "oviposition (DT216)", "oviposition (DT245)", "broutage de surface (DT30)")
library(plot.matrix)
GLbyType <- matrix(c(1:779), nrow = 19, ncol = 41, byrow = T)
for (j in 1:19) {
  for (i in 1:41) {
   GLbyType[j,i] <- length(which(Morphotype[Type == DTclass[i]] == orderedmorphotype[j]))   
   }
}
rownames(GLbyType) <- orderedmorphotype
colnames(GLbyType) <- DTclass
plot(GLbyType, fmt.cell='%.0f', fmt.key="%.0f", breaks=c(1,9), col = rev(topo.colors(10)))
Datadeg_Damaged_only_genus <- Datadeg_Damaged_only
detach(Datadeg_Damaged_only)
attach(Datadeg_Damaged_only_genus)
Morphotype[Morphotype == "GL5"] <- "GL2"
Morphotype[Morphotype == "GL8"] <- "GL2"
Morphotype[Morphotype == "GL11"] <- "GL3"
Morphotype[Morphotype == "GL29"] <- "GL3"
Morphotype[Morphotype == "GL22"] <- "GL4"
Morphotype[Morphotype == "GL23"] <- "GL4"
Morphotype[Morphotype == "GL24"] <- "GL4"
Morphotype[Morphotype == "GL25"] <- "GL4"
Morphotype[Morphotype == "GL13"] <- "GL10"
Morphotype[Morphotype == "GL15"] <- "GL12"
Morphotype[Morphotype == "GL27"] <- "GL26"
orderedmorphotypegenus <- c("GL1", "GL2", "GL3", "GL4", "GL6", "GL10", "GL12", "GL19", "GL26", "GL30", "GLU")
GLgenusbyType <- matrix(c(1:451), nrow = 11, ncol = 41, byrow = T)
for (j in 1:11) {
  for (i in 1:41) {
    GLgenusbyType[j,i] <- length(which(Morphotype[Type == DTclass[i]] == orderedmorphotypegenus[j]))   
  }
}
rownames(GLgenusbyType) <- orderedmorphotypegenus
colnames(GLgenusbyType) <- DTclass
plot(GLgenusbyType, fmt.cell='%.0f', fmt.key="%.0f", breaks=c(1,11), col = rev(topo.colors(10)))

#courbe de rarfaction
library(vegan)
raredeg <- cbind(Datadegterr, matrix(0, ncol = 41, nrow = 654))
orderedtypeglobal <- as.character(c(1:41))
for (k in 1:41) {
  raredeg[raredeg$Type == orderedtypeglobal[k], k+8] <- 1
  raredeg[raredeg$Type.1 == orderedtypeglobal[k], k+8] <- 1
}
row.names(raredeg) <- raredeg[,2]
raredeg <- raredeg[, -c(1:3, 5:8)]
plot(specaccum(raredeg[, -1], method = "rarefaction"))
specpool(raredeg[, -1])

#diversit de dgts sur Dryophyllum sp. entre Mnat et Gelinden
div_deg_dryophyllum <- matrix(c(3,3,1,13,2,4,1,0,0,1,1,1,1,0,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2,0,0,5,0,2,0,1,1,0,0,0,0,6,0,5,2,1,1,2,1,1,2,1,11,5,1,1,4,2,2), ncol = 31, nrow = 2, byrow = T, dimnames = list(c("Mnat", "Gelinden"), c("DT02","DT03","DT05","DT12","DT14","DT15","DT16","DT30","DT32","DT41","DT68","DT78","DT79","DT80","DT95","DT125","DT165","DT188","DT189","DT200","DT216","DT241","DT245","DT254","DT263","DT289","DT290","DT334","DT354","DT388","DT409")))
div_deg_dryophyllum
diversity(div_deg_dryophyllum, index = "simpson")
diversity(div_deg_dryophyllum, index = "invsimpson")
diversity(div_deg_dryophyllum, index = "shannon", base = exp(1))

raredeg_dryo_gelinden <- rbind(raredeg[c(raredeg$Morphotype == "GL2"), -c(2, 3, 7, 11, 12, 13, 14, 21, 23, 25, 27, 29, 33, 34, 36, 37, 40, 41, 42)], raredeg[c(raredeg$Morphotype == "GL5"), -c(2, 3, 7, 11, 12, 13, 14, 21, 23, 25, 27, 29, 33, 34, 36, 37, 40, 41, 42)], raredeg[c(raredeg$Morphotype == "GL8"), -c(2, 3, 7, 11, 12, 13, 14, 21, 23, 25, 27, 29, 33, 34, 36, 37, 40, 41, 42)])
plot(specaccum(raredeg_dryo_gelinden[, -1], method = "rarefaction"))
specpool(raredeg_dryo_gelinden[, -1])
), nrow = 11, ncol = 41, byrow = T)
for (j in 1:11) {
  for (i in 1:41) {
    GLgenusbyType[j,i] <- length(which(Morphotype[Type == DTclass[i]] == orderedmorphotypegenus[j]))   
  }
}
rownames(GLgenusbyType) <- orderedmorphotypegenus
colnames(GLgenusbyType) <- DTclass
plot(GLgenusbyType, fmt.cell='%.0f', fmt.key="%.0f", breaks=c(1,11), col = rev(topo.colors(10))